#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;


int main() 
{
	int n1, m, n ;
	cin>>n1;
	int l;
	long long r, r1 ;
	int k=1;
	for (int i=0; i<n1; i++)
	{
		k=1;
		cin>>n>>m;
		long long a[n];
		for (int j=0; j<n; j++)
		{
		cin>>a[j];	
			
		}
		r=abs(a[0]-a[1]);
		
		for (int j=1; j<n-1;j++)
		{
		
		r1=abs(a[j+1]-a[j]);
		
		r=__gcd(r,r1) ;	
	
			
			
		}
		
		
		long long b[m];
		for (int j=0; j<m; j++)
		{
		cin>>b[j];	
		}
		 if(r!=1)
		 {
		 for (int j=0; j<m; j++)
		 
		 {
		 if (b[j]%r==a[0]%r)
		 {
		 k=0;
		 
		 
		 }	
		 
		 }
		cout<<k<<endl; 
		
		 }
		else 
		{
		k=0;
		cout<<k<<endl;	
		}
		
	}
	
	
	return 0;
}